# CheapWireCut by David Bowland
# ./addons/eventscripts/cheapwirecut/cheapwirecut.py

# >>> To configure this addon please see cheapwirecut.cfg (created whent he addon is first loaded) <<<

"""
Allows player to instantly defuse the bomb at the risk of detonation.
Requires only ES 2.1+ and CheapPopup (http://addons.eventscripts.com/addons/view/cheappopup)
"""

from __future__ import division, with_statement

import cfglib
import es
import gamethread
import langlib
import playerlib
import random
import usermsg

import psyco
psyco.full()

from path import path

from cheappopup import *

popup = CheapPopup()


info = es.AddonInfo()
info.name     = 'CheapWireCut'
info.version  = '5'
info.basename = 'cheapwirecut'
info.url      = 'http://addons.eventscripts.com/addons/view/' + info.basename
info.author   = 'SuperDave'


addonpath = path(es.getAddonPath(info.basename))

###

config = cfglib.AddonCFG(addonpath.joinpath(info.basename + '.cfg'))

config.text(info.name + ' release %s options' % info.version)
config.text('./addons/eventscripts/%(basename)s/%(basename)s.cfg' % {'basename': info.basename})
config.text(info.url)
config.text('')
config.text('Load this addon with: es_load ' + info.basename)
config.text('THIS ADDON REQUIRES CheapPopup TO FUNCTION: es_install cheappopup')
config.text('Or: http://addons.eventscripts.com/pages/cheappopup')
config.text('\n')
config.text('To configure language settings for %s please see %s_languages.ini' % (info.name, info.basename))
config.text('\n')
config.text('Thanks to 7355608 for this script idea. CutWires can be found here:')
config.text('http://addons.eventscripts.com/addons/view/cutwires')
config.text('')
config.text('Thanks also to *X*Y*Z*SaYnt. HailMary can be found here:')
config.text('http://addons.eventscripts.com/addons/view/hailmary')
config.text('\n')
config.text('This addon is compatible with CheapBombTimer, which can be found here:')
config.text('http://addons.eventscripts.com/addons/view/cheapbombtimer')
config.text('\n')

config.text('***** General options *****')
cvar_pull = config.cvar('cheapwirecut_pull', 65, 'Percent chance pulling a wire detonates the bomb')
cvar_cut  = config.cvar('cheapwirecut_cut',  28, 'Percent chance cutting a wire (defuse kit only) detonates the bomb')
config.text('\n')

config.text('***** BPS option *****')
cvar_bps = config.cvar('cheapwirecut_bps', 83, 'Bomb beeps per second (x 10)')
config.text('To test your cheapwirecut_bps setting load CheapWireCut, plant the bomb and let it explode.')
config.text('If your cheapwirecut_bps setting is incorrect you will be told the correct value when the bomb explodes.')
config.text('\n')

config.text('***** Minigame options *****')
cvar_minigame        = config.cvar('cheapwirecut_minigame',        1,            '0 = no change, 1 = players planting the bomb will be prompted to select menu items to increase detonation chance')
cvar_minigame_digits = config.cvar('cheapwirecut_minigame_digits', '0123456789', 'Digits possible in the minigame--only 1 through 9 will increase explosion chance, 0 will omit the selection')
cvar_minigame_pull   = config.cvar('cheapwirecut_minigame_pull',   6,            'Percentage points added to the detonation chance of pulling a wire by pressing the correct digit in the minigame')
cvar_minigame_cut    = config.cvar('cheapwirecut_minigame_cut',   12,            'Percentage points added to the detonation chance of cutting a wire by pressing the correct digit in the minigame')
config.text('\n')

config.text('***** Bot options *****')
cvar_bot_defuse_percent   = config.cvar('cheapwirecut_bot_defuse_percent',   85, 'Maximum chance of explosion allowed for a bot to pull or cut a wire--set to 0 to eliminate')
cvar_bot_defuse_perceived = config.cvar('cheapwirecut_bot_defuse_perceived', 50, 'Maximum perceived chance of explosion for a bot to pull or cut a wire--set to 0 to eliminate')
cvar_bot_defuse_hurt      = config.cvar('cheapwirecut_bot_defuse_hurt',      80, 'Percent chance a bot will pull or cut a wire if attacked while defusing--set to 0 to eliminate')
cvar_bot_defuse_threshold = config.cvar('cheapwirecut_bot_defuse_threshold', 2,  'Bomb time in seconds below which bots will prefer to pull or cut a wire rather than be defusing')
cvar_bot_minigame_chance  = config.cvar('cheapwirecut_bot_minigame_chance',  70, 'Percent chance a bot will increase the chance of detonation with the minigame')
cvar_bot_minigame_max     = config.cvar('cheapwirecut_bot_minigame_max',     5,  'Maximum number of times a bot can increase the chance of detonation with the minigame--set to 0 to eliminate')
config.text('\n')

config.text('***** Announcement options *****')
cvar_announce_percent_chat   = config.cvar('cheapwirecut_announce_percent_chat',   2, '0 = no change, 1 = announce the percent chance of detonation from pulling or cutting wire on the console to Terrorists, 2 = announce the percent chance of detonation from pulling or cutting wire in chat area to Terrorists, 3 = announce the percent chance of detonation from pulling or cutting wire on the console to all players, 4 = announce the percent chance of detonation from pulling or cutting wire in chat area to all players')
cvar_announce_percent_center = config.cvar('cheapwirecut_announce_percent_center', 0, '0 = no change, 1 = announce the percent chance of detonation from pulling or cutting wire in center text to Terrorists, 2 = announce the percent chance of detonation from pulling or cutting wire in center text to all players')
cvar_announce_percent_hud    = config.cvar('cheapwirecut_announce_percent_hud',    1, '0 = no change, 1 = announce the percent chance of detonation from pulling or cutting wire in a HUD message to Terrorists, 2 = announce the percent chance of detonation from pulling or cutting wire in a HUD message to all players')
cvar_announce_result_chat    = config.cvar('cheapwirecut_announce_result_chat',    4, '0 = no change, 1 = announce when a wire is cut or pulled on the console, 2 = announce when a wire is cut or pulled in chat area, 3 = announce when the bomb is defused normally and when a wire is cut or pulled on the console, 4 = announce when the bomb is defused normally and when a wire is cut or pulled in chat area')
cvar_announce_result_center  = config.cvar('cheapwirecut_announce_result_center',  0, '0 = no change, 1 = announce when a wire is cut or pulled in center text, 2 = announce when the bomb is defused normally and when a wire is cut or pulled in center text')
cvar_announce_result_hud     = config.cvar('cheapwirecut_announce_result_hud',     2, '0 = no change, 1 = announce when a wire is cut or pulled in a HUD message, 2 = announce when the bomb is defused normally and when a wire is cut or pulled in a HUD message')
config.text('\n')

config.text('***** Event documentation *****')
config.text('')
config.text('The following events will fire when CheapWireCut is loaded:')
config.text('')
config.text('bomb_wire')
config.text('- Fires when a player pulls or cuts a wire on the bomb BEFORE bomb_defused or bomb_exploded')
config.text('   event_var(userid)          - Userid of the player who pulled or cut a wire')
config.text('   event_var(action)          - Action performed ("PULL", "CUT")')
config.text('   event_var(result)          - Result of pulling or cutting the wire ("DEFUSED", "EXPLODED")')
config.text('')
config.text('cheapwirecut_minigame')
config.text('   event_var(userid)          - Userid of the player in the minigame')
config.text('   event_var(action)          - Action performed ("ADD_TO_CUT", "ADD_TO_PULL", "RESET", "FINISH", "CANCEL")')
config.text('   event_var(pull)            - Percent chance a pulled wire will explode')
config.text('   event_var(cut)             - Percent chance a cut wire will explode')
config.text('')
config.text('These events also provide event_var(es_steamid), event_var(es_username), and all the other event_vars that accompany')
config.text('event_var(userid). More information can be found here: http://www.eventscripts.com/pages/Extended_event_variables')

config.write()

###

ini = cfglib.AddonINI(addonpath.joinpath(info.basename + '_languages.ini'))

ini.setInitialComments([
 '# ./addons/eventscripts/%(basename)s/%(basename)s_languages.ini' % {'basename': info.basename},
 '# >>> For general addon configuration see ' + info.basename + '.cfg <<<',
 '',
 '# DO NOT translate words with $ or # in front!',
 '# For a list of language abbreviations please see ./addons/eventscripts/_libs/python/deflangs.ini'])

ini.addGroup('pull header')
ini.addValueToGroup('pull header', 'en', 'Pull wire option:')

ini.addGroup('pull cut header')
ini.addValueToGroup('pull cut header', 'en', 'Pull or cut wire option:')

ini.addGroup('pull option')
ini.addValueToGroup('pull option', 'en', 'Pull a wire')

ini.addGroup('cut option')
ini.addValueToGroup('cut option', 'en', 'Cut a wire')

ini.addGroup('pull cut chance')
ini.addValueToGroup('pull cut chance', 'en', '($percent% chance of detonation)')

ini.addGroup('minigame pull header')
ini.addValueToGroup('minigame pull header', 'en', '$pull percent chance pulling a wire detonates')

ini.addGroup('minigame cut header')
ini.addValueToGroup('minigame cut header', 'en', '$cut percent chance cutting a wire detonates')

ini.addGroup('minigame pull option')
ini.addValueToGroup('minigame pull option', 'en', '+$increase% for pulling a wire')

ini.addGroup('minigame cut option')
ini.addValueToGroup('minigame cut option', 'en', '+$increase% for cutting a wire')

ini.addGroup('cancel')
ini.addValueToGroup('cancel', 'en', 'Cancel')

ini.addGroup('defused normal p1')
ini.addValueToGroup('defused normal p1', 'en', '#lightgreen$player#default defused the bomb')

ini.addGroup('defused pull p1')
ini.addValueToGroup('defused pull p1', 'en', '#lightgreen$player#default pulled a wire and defused the bomb')

ini.addGroup('defused cut p1')
ini.addValueToGroup('defused cut p1', 'en', '#lightgreen$player#default cut a wire and defused the bomb')

ini.addGroup('exploded pull p1')
ini.addValueToGroup('exploded pull p1', 'en', '#lightgreen$player#default pulled a wire and detonated the bomb')

ini.addGroup('exploded cut p1')
ini.addValueToGroup('exploded cut p1', 'en', '#lightgreen$player#default cut a wire and detonated the bomb')

ini.addGroup('defused exploded singular p2')
ini.addValueToGroup('defused exploded singular p2', 'en', 'with #lightgreen1 second#default on the timer.')

ini.addGroup('defused exploded plural p2')
ini.addValueToGroup('defused exploded plural p2', 'en', 'with #lightgreen$seconds seconds#default on the timer.')

ini.addGroup('percent text')
ini.addValueToGroup('percent text', 'en', '#lightgreen$pull percent#default chance #lightgreenpulling#default a wire detonates and #lightgreen$cut%#default chance #lightgreencutting#default a wire detonates.')

ini.write()
lang_text = langlib.Strings(ini)

###

class EventContext(object):
   def __init__(self, name):
      self.name = name

   def __enter__(self):
      es.event('initialize', self.name)
      return self

   def __exit__(self, type_, value, traceback_):
      es.event('fire', self.name)
      # Not returning True causes any exceptions to be re-raised

   def set(self, type_, item, value):
      es.event('set' + type_, self.name, item, value)

###

class CheapWireCutManager(object):
   """ Controls the base functionality of CheapWireCut """

   bps = 1
   start_time = 0
   menuuserid = 0
   mp_c4timer = es.ServerVar('mp_c4timer')

   def __init__(self):
      self.mg_choices = {}
      self.hurt_bots  = set()
      self.resetTicks()

   """ Bomb functions """

   def resetTicks(self):
      """ Resets the bomb ticks and other information """
      self.ticks = -1

      self.mg_choices.clear()
      self.hurt_bots.clear()

      popup.closeAll()
      self.resetWires()

   def resetWires(self):
      """ Resets the wires to their original values """
      self.wires = {'pull': int(cvar_pull), 'cut': int(cvar_cut)}

   def bombAbortPlant(self):
      """ Cancels the minigame if the bomb planting is aborted """
      if self.menuuserid:
         self.miniGameEvent(self.menuuserid, 'CANCEL')
         popup.closeAll()

   def bombPlanted(self):
      """ Finishes the minigame when the bomb is planted """
      if self.menuuserid:
         self.miniGameEvent(self.menuuserid, 'FINISH')
         popup.closeAll()

      # Sets up the information for the new bomb
      self.bps        = cvar_bps / 10
      self.ticks      = 0
      self.start_time = int(self.mp_c4timer)

      # Displays the wire percentages
      chat   = int(cvar_announce_percent_chat)
      center = int(cvar_announce_percent_center)
      hud    = int(cvar_announce_percent_hud)

      if chat or center or hud:
         for userid in es.getUseridList():
            player_lang = playerlib.getPlayer(userid).getLanguage()
            isterrorist = es.getplayerteam(userid) != 3

            if chat == 3 or (chat == 1 and isterrorist):
               usermsg.echo(userid, self.removeTags(lang_text('percent text', self.wires, player_lang)))
            elif chat == 4 or (chat and isterrorist):
               es.tell(userid, '#multi', lang_text('percent text', self.wires, player_lang))
            if center == 2 or (center and isterrorist):
               es.centertell(userid, self.removeTags(lang_text('percent text', self.wires, player_lang)))
            if hud == 2 or (hud and isterrorist):
               line1 = lang_text('minigame pull header', self.wires, player_lang)
               line2 = lang_text('minigame cut header',  self.wires, player_lang)
               usermsg.hudhint(userid, line1.center(len(line2)) + '\n' + line2.center(len(line1)))

   def bombBeginDefuse(self, userid):
      """ Give the pull/cut options when a player starts to defuse the bomb """
      self.menuuserid = userid
      player = playerlib.getPlayer(userid)
      has_defuser = player.hasDefuser()

      # If the players ia bot decide whether to pull or cut a wire
      if es.getplayersteamid(userid) == 'BOT':
         selection, action = (3, 'pull') if self.wires['pull'] > self.wires['cut'] and has_defuser else (1, 'cut')

         # Take into account the bomb time, time to defuse, and number of living players on each team
         if self.getBombTime() - (5 if has_defuser else 10) < cvar_bot_defuse_threshold:
            self.wireAction(userid, selection)
         else:
            t_count         = es.getlivingplayercount(2)
            perceived_value = min(max(self.wires[action] * es.getlivingplayercount(3) / t_count , 0), 100) if t_count else 100
            if perceived_value <= cvar_bot_defuse_perceived and self.wires[action] <= cvar_bot_defuse_percent:
               self.wireAction(userid, selection)

      # If the player is a human give him or her the pull/cut choice
      else:
         player_lang = player.getLanguage()
         if has_defuser: # Can pull or cut
            popup.sendMenu(userid, 0,
             lang_text('pull cut header', lang=player_lang) + '\n ' +
             '\n->1. ' + lang_text('pull option', lang=player_lang) +
             '\n' + lang_text('pull cut chance', {'percent': self.wires['pull']}, player_lang) +
             '\n ' +
             '\n->3. ' + lang_text('cut option', lang=player_lang) +
             '\n' + lang_text('pull cut chance', {'percent': self.wires['cut']}, player_lang) +
             '\n ' +
             '\n0. ' + lang_text('cancel', lang=player_lang), self.wireAction)
         else: # Pull only
            popup.sendMenu(userid, 0,
             lang_text('pull header', lang=player_lang) + '\n ' + 
             '\n->1. ' + lang_text('pull option', lang=player_lang) +
             '\n' + lang_text('pull cut chance', {'percent': self.wires['pull']}, player_lang) +
             '\n '
             '\n0. ' + lang_text('cancel', lang=player_lang), self.wireAction)

   def bombDefused(self, userid):
      """ Closes the wire menu when the bomb is defused """
      if self.ticks != -1:
         if int(cvar_announce_result_chat) in (3, 4) or cvar_announce_result_center == 2 or cvar_announce_result_hud == 2:
            self.announceResult('normal', 'defused', userid)
         self.resetTicks()

   def bombExploded(self):
      """
      Closes wire menu when the bomb explodes
      Checks the number of ticks against the bps setting to ensure the bomb countdown is correct
      """
      popup.closeAll()
      if self.ticks != -1:
         self.ticks += 1

         # If the stored BPS is incorrect we need to tell the players and correct the
         # problem so it doesn't further affect CWC and the message isn't shown again
         bps = int(round((self.ticks + 1) / self.start_time * 10))
         if bps != self.bps * 10.:
            es.centermsg('cheapwirecut_bps incorrectly configured!')
            es.msg('cheapwirecut_bps incorrectly configured!')
            es.msg('You should change your cheapwirecut_bps value to %s' % bps)
            es.msg('This setting can found in your cheapwirecut.cfg')
            cvar_bps.set(bps)

   def tick(self):
      """ Adds a tick to the number of bomb ticks """
      if self.ticks != -1:
         self.ticks += 1
      else:
         popup.closeAll()

   def playerHurt(self, userid):
      """ Forces a bot to pull or cut a wire if the bot is hurt """
      if es.getplayersteamid(userid) != 'BOT' or self.ticks == -1:
         return

      # If the bot has already been hurt while defusing it won't care anymore
      player = playerlib.getPlayer(userid)
      if not player.isDefusing() or userid in self.hurt_bots:
         return

      # Marks this bot as being hurt while defusing
      self.hurt_bots.add(userid)
      # Determine the behavior of a bot that is hurt while defusing
      if random.randint(1, 100) > cvar_bot_defuse_hurt:
         return

      # The bot is going to pull or cut
      if player.hasDefuser() and self.wires['pull'] >= self.wires['cut']:
         # The bot has a defuser and the cut action is less likely to
         # explode then the pull option, cut the wire
         if cvar_bot_defuse_percent >= self.wires['cut']:
            self.wireAction(userid, 3)
      elif cvar_bot_defuse_percent >= self.wires['pull']:
         # If the bot has no defuser or the cut action is more dangerous,
         # pull the wire
         self.wireAction(userid, 1)

   def playerDisconnect(self, userid):
      """ Removes the disconnecting from the userid using the menu """
      if userid == self.menuuserid:
         self.menuuserid = 0

   def wireAction(self, userid, item):
      """ Explodes or defuses the bomb when a wire is pulled or cut"""
      # Invalid selection, do nothing
      if item not in (1, 3) or (item != 1 and not playerlib.getPlayer(userid).hasDefuser()):
         return

      # If the C4 can't be found we can't explode it or defuse it
      c4_index = es.getentityindex('planted_c4')
      if c4_index == -1:
         es.dbgmsg(0, 'CheapWireCut: Could not find C4!')
         return

      # Choose whether to blow up or defuse the bomb
      action = 'pull' if item == 1 else 'cut'
      if random.randint(1, 100) <= self.wires[action]:
         # If CheapBombTimer is loaded we let it know we're going to blow up the bomb early
         if es.exists('variable', 'cheapbombtimer_bps_skipcheck'):
            es.ServerVar('cheapbombtimer_bps_skipcheck').set(1)

         # Boom!
         es.setindexprop(c4_index, 'CPlantedC4.m_flC4Blow', 1)
         result = 'exploded'
      else: # Bomb defused
         es.setindexprop(c4_index, 'CPlantedC4.m_flDefuseCountDown', 1)
         result = 'defused'

      # Fire bomb_wire event
      with EventContext('bomb_wire') as event:
         event.set('int', 'userid', userid)
         event.set('string', 'action', action.upper())
         event.set('string', 'result', result.upper())

      # Remove player's progress bar, accounce the wire result, and resets the bomb ticks
      es.setplayerprop(userid, 'CCSPlayer.m_iProgressBarDuration', 0)
      self.announceResult(action, result, userid)
      self.resetTicks()

   def getBombTime(self):
      """ Returns the remaining bomb time in seconds """
      return self.start_time - self.ticks / self.bps

   """ Minigame functions """

   def miniGame(self, userid):
      """ Starts the minigame if it's enabled """
      if not cvar_minigame:
         return
      self.resetWires() #new minigame so reset the wires

      # If the player is a bot we need to mimic it playing the minigame
      if es.getplayersteamid(userid) == 'BOT':
         bot_chance    = int(cvar_bot_minigame_chance)
         wire_addition = {'pull': int(cvar_minigame_pull), 'cut': int(cvar_minigame_cut)}

         for x in xrange(cvar_bot_minigame_max):
            if random.randint(1, 100) <= bot_chance: # Bot used valid selection
               action = random.choice(('pull', 'cut'))
               self.wires[action] = min(wire_addition[action] + self.wires[action], 100)
               self.miniGameEvent(userid, 'ADD_TO_' + action.upper())
            else: # Bot failed minigame
               self.resetWires()
               self.miniGameEvent(userid, 'RESET')
               return
         self.miniGameEvent(userid, 'FINISH')

      # We send the minigame menu to human players
      else:
         self.menuuserid = userid
         self.miniGameMenu(userid)

   def miniGameMenu(self, userid, lastoption=None):
      """ Checks the minigame selection to see if the player advanced or failed """
      choices = map(int, str(cvar_minigame_digits))
      if lastoption in choices:
         choices.remove(lastoption) # Don't pick the last option used

      # Pick the minigame selections and send them to the player
      if len(choices) > 1:
         self.mg_choices.clear()

         # Select a random number for pull chance detonation increase
         current_choice = random.choice(choices)
         self.mg_choices[current_choice] = 'pull'

         # Select a random number for cut chance detonation increase
         choices.remove(current_choice)
         current_choice = random.choice(choices)
         self.mg_choices[current_choice] = 'cut'

         # Create menu header
         player_lang = playerlib.getPlayer(userid).getLanguage()
         menu_text   = (lang_text('minigame pull header', self.wires, player_lang) + '\n' + 
          lang_text('minigame cut header', self.wires, player_lang) + '\n \n')

         # Builds the current choices into a menu
         for current_choice in sorted(self.mg_choices):
            if current_choice != 0:
               action = self.mg_choices[current_choice]
               if self.wires[action] < 100:
                  menu_text += ('->' + str(current_choice) + '. ' +
                   lang_text('minigame ' + action + ' option',
                    {'increase': str(es.ServerVar('cheapwirecut_minigame_' + action))}, player_lang) +
                   '\n \n')
         popup.sendMenu(userid, 0, menu_text + '0. ' + lang_text('cancel', lang=player_lang), self.miniGameChoice)

      # The minigame can't be played due to not enough digits to select from
      else:
         es.dbgmsg(0, 'CheapWireCut: Insufficient number of digits in cheapwirecut_minigame_digits')
         self.closeMenus()

   def miniGameChoice(self, userid, item):
      """ Performs the requisite action when a minigame selection is made """
      if item in self.mg_choices: # Good minigame selection, increase detonation percent
         action = self.mg_choices[item]
         self.wires[action] = min(es.ServerVar('cheapwirecut_minigame_' + action) + self.wires[action], 100)
         self.miniGameEvent(userid, 'ADD_TO_' + action.upper())
         self.miniGameMenu(userid, item)
      elif item == 10: # Quit minigame
         self.miniGameEvent(userid, 'CANCEL')
         self.menuuserid = 0
      else: # Not a valid choice -- fail!
         self.resetWires()
         self.miniGameEvent(userid, 'RESET')
         self.menuuserid = 0
      return False

   def miniGameEvent(self, userid, action):
      """ Fires cheapwirecut_minigame with the given userid and action """
      with EventContext('cheapwirecut_minigame') as event:
         event.set('int', 'userid', userid)
         event.set('string', 'action', action)
         event.set('int', 'pull', self.wires['pull'])
         event.set('int', 'cut', self.wires['cut'])

   """ Announcment functions """

   def announceResult(self, action, result, userid):
      """ Announces the result of a wire action (exploded/defused) """
      chat   = int(cvar_announce_result_chat)
      center = int(cvar_announce_result_center)
      hud    = int(cvar_announce_result_hud)

      if chat or center or hud:
         remaining_time = int(self.getBombTime())
         tokens = {'seconds': remaining_time, 'player': es.getplayername(userid)}

         p1 = result + ' ' + action + ' p1'
         p2 = 'defused exploded singular p2' if remaining_time == 1 else 'defused exploded plural p2'

         for loop_userid in es.getUseridList():
            player_lang = playerlib.getPlayer(loop_userid).getLanguage()
            text = lang_text(p1, tokens, player_lang) + ' ' + lang_text(p2, tokens, player_lang)
            if chat in (1, 3):
               usermsg.echo(loop_userid, self.removeTags(text))
            elif chat:
               es.tell(loop_userid, '#multi', text)
            if center:
               es.centertell(loop_userid, self.removeTags(text))
            if hud:
               usermsg.hudhint(loop_userid, self.removeTags(text))

   """ Static methods """

   @staticmethod
   def removeTags(text):
      """ Returns text without color tags """
      return reduce(lambda t, r: t.replace(r, ''), ('#lightgreen', '#darkgreen', '#green', '#default'), text)

   @staticmethod
   def loadEvents():
      """ Loads the .res file for the events """
      if addonpath.joinpath(info.basename + '.res').isfile():
         es.loadevents('declare', 'addons/eventscripts/%(basename)s/%(basename)s.res' % {'basename': info.basename})

      else:
         events = {'bomb_wire': {'userid': 'short', 'action': 'string', 'result': 'string'},
          'cheapwirecut_minigame': {'userid': 'short', 'action': 'string', 'pull': 'short', 'cut': 'short'}}

         if not addonpath.joinpath('es_' + info.basename + '_events_db.txt').isfile():
            es.keygroupcreate(info.basename + '_events')
            for event_name in events:
               es.keycreate(info.basename + '_events', event_name)
               for event_var in events[event_name]:
                  es.keysetvalue(info.basename + '_events', event_name, event_var, events[event_name][event_var])
            es.keygroupsave(info.basename + '_events', '|' + info.basename)
            es.keygroupdelete(info.basename + '_events')
         es.loadevents('declare', 'addons/eventscripts/' + info.basename + '/es_' + info.basename + '_events_db.txt')
         es.dbgmsg(0, info.name + ': Unable to load ' + info.basename + '.res! Please ensure it is in the ./' + info.basename + '/ directory.')

cwc = CheapWireCutManager()

###

def load():
   config.execute()
   cwc.loadEvents()


def es_map_start(event_var):
   cwc.loadEvents()


def round_start(event_var):
   cwc.resetTicks()


def bomb_beginplant(event_var):
   cwc.miniGame(int(event_var['userid']))


def bomb_abortplant(event_var):
   cwc.bombAbortPlant()


def bomb_planted(event_var):
   cwc.bombPlanted()


def bomb_beep(event_var):
   cwc.tick()


def bomb_begindefuse(event_var):
   cwc.bombBeginDefuse(int(event_var['userid']))


def bomb_abortdefuse(event_var):
   popup.closeMenu(event_var['userid'])


def bomb_defused(event_var):
   cwc.bombDefused(int(event_var['userid']))


def bomb_exploded(event_var):
   cwc.bombExploded()


def player_hurt(event_var):
   cwc.playerHurt(int(event_var['userid']))


def unload():
   popup.unload()

   for cvar in config.getCvars():
      es.ServerVar(cvar).set(0)